;
;	PC-8801 ROM zovOi}Vp[gj
;	written by H.Kanemoto., 1997/10/05
;
;
		ORG	0C000h

		JR	main
;-----------------------------------------------------------------------------
start_addr:	DB	00h,00h
size_of_rom:	DB	00h,80h
;-----------------------------------------------------------------------------
main:		LD	B,(HL)		; arg2 = N80/N88 rom selector
		INC	HL
		LD	A,(HL)		; arg1 = 4th ROM enable/disable
		OUT	(71h),A
		LD	A,(0E6C2h)	; bank select ROM
		AND	0f9h
		OR	B
		OUT	(31h),A

		LD	IX,(start_addr)
		LD	DE,(size_of_rom)
		CALL	term

		LD	A,0ffh		; disable 4th ROM
		OUT	(71h),A
		LD	A,(0E6C2h)	; restore bank
		OUT	(31h),A
		RET

;-----------------------------------------------------------------------------
;	IN: IX  pointer to buffer
;	    DE  length for transfer
;-----------------------------------------------------------------------------
term:		DI
		LD	B,10h
loop:		LD	A,(IX+00h)	; ]f[^ǂݍ
		PUSH	AF
		SRL	A		; ʂSbit
		SRL	A
		SRL	A
		SRL	A
		CALL	transfer
		POP	AF
		AND	0fh		; ʂSbit
		CALL	transfer
		DEC	B		; s 16byte H
		JR	NZ,next_char
		CALL	send_cr
		LD	B,10h
next_char:	INC	IX		; ++ ]AhX
		DEC	DE		; -- ]JEg
		LD	A,D
		OR	E
		JR	NZ,loop
		EI
		RET

transfer:	LD	HL,table	; ɕϊ
		ADD	A,L
		LD	L,A
		LD	A,(HL)
		CALL	send_data	; M
		RET

send_cr:	LD	A,0dh		; sR[ho
		CALL	send_data
		LD	A,0ah
		CALL	send_data
		RET

send_data:	PUSH	AF
wait:		IN	A,(21h)		; USART M Ready?
		RRCA
		JR	NC,wait
		POP	AF
		OUT	(20h),A
		RET

;-----------------------------------------------------------------------------
;	DATA AREA
;-----------------------------------------------------------------------------
table:		DB	'0123456789ABCDEF'

		END
